'Master program on Maximite
'mandelbrot parallel processing
'Henk Verbeek Amsterdam The Netherlands 2015


tel=0
lreceive=9 'lenght data to receive

I2C open 300,1000
inputdata
sendvar

Cls
mandelbrot
End

Sub inputdata
Input "Aantal verbonden slaves=";slave$
sp=Len(slave$):slave$=slave$+Space$(5-a)
Input "Real offset=";re$
sp=Len(re$):re$=re$+Space$(5-a)
Input "Imaginairy offset=";im$
sp=Len(im$):im$=im$+Space$(5-a)
Input "Crealval=";cr$
sp=Len(cr$):cr$=cr$+Space$(5-a)
Input "Cimagcal=";ci$
sp=Len(ci$):ci$=ci$+Space$(5-a)
Input "maximum iterations";max$
sp=Len(max$):max$=max$+Space$(5-a)
End Sub

Sub sendvar 'realoff,imaginoff,crealval,cimagval,maxit
For start=8 To 7+Val(slave$) 'send variables to slave addresses
I2C write start,0,5,slave$
I2C write start,0,5,re$
I2C write start,0,5,im$
I2C write start,0,5,cr$
I2C write start,0,5,ci$
I2C write start,0,5,max$
Next start
End Sub

Sub mandelbrot
Timer=0
Mode 3
pixelwidth=MM.HRes
pixelheight=MM.VRes
a=8 ' start first slave address

Do While tel<>4
I2C read a,1,lreceive,t$
a=a+1:If a=Val(slave$)+8 Then a=8
Pixel(Val(Left$(t$,3)),Val(Mid$(t$,5,3)))=Val(Mid$(t$,9,1))
If Val(Left$(t$,3))=999 Then tel=tel+1 Else tel=0
Loop

Print@(0,410);"Time taken ";Timer/1000;" seconds"
I2C close

Do
a$=Inkey$
Loop While a$=""
End Sub
